diff --exclude=CVS --exclude=.cvsignore -Nur olsrd-0.5.0/lib/bmf/src/Bmf.c olsrd-current/lib/bmf/src/Bmf.c
--- olsrd-0.5.0/lib/bmf/src/Bmf.c	2007-02-10 18:05:55.000000000 +0100
+++ olsrd-current/lib/bmf/src/Bmf.c	2007-04-22 19:40:38.000000000 +0200
@@ -568,60 +630,59 @@
 
   if (EtherTunTapFd >= 0)
   {
-    struct sockaddr broadAddr;
+    /* Unpack the encapsulated Ethernet packet and send a copy to myself via
+     * the EtherTunTap interface */
+
+    union olsr_ip_addr broadAddr;
+    int nBytesToWrite, nBytesWritten;
+    unsigned char* bufferToWrite;
+
+    /* If the encapsulated Ethernet frame is an IP local broadcast packet,
+     * update its destination address to match the subnet of the EtherTunTap
+     * interface */
+    broadAddr.v4 = htonl(EtherTunTapIpBroadcast);
+    CheckAndUpdateLocalBroadcast(GetIpPacket(ethernetFrame), &broadAddr);
+
+    /* Start off by assuming a TAP device */
+    bufferToWrite = ethernetFrame;
+    nBytesToWrite = ethernetFrameLen;
 
-    /* Unpack encapsulated packet and send a copy to myself via the EtherTunTap interface */
-    bufferToWrite = ethPkt;
-    nBytesToWrite = ethPktLen;
+    /* If we're using the TUN device instead, we need to write an IP packet instead
+     * of an Ethernet packet */
     if (TunOrTap == TT_TUN)
     {
       bufferToWrite += IP_HDR_OFFSET;
       nBytesToWrite -= IP_HDR_OFFSET;
     }
 
-    ((struct sockaddr_in*)&broadAddr)->sin_addr.s_addr = htonl(EtherTunTapIpBroadcast);
-    CheckAndUpdateLocalBroadcast(ethPkt, &broadAddr);
-
     nBytesWritten = write(EtherTunTapFd, bufferToWrite, nBytesToWrite);
     if (nBytesWritten != nBytesToWrite)
     {
-      olsr_printf(
-        1,
-        "%s: write() error forwarding encapsulated pkt to \"%s\": %s\n",
-        PLUGIN_NAME,
-        EtherTunTapIfName,
-        strerror(errno));
+      BmfPError("write() error forwarding encapsulated pkt on \"%s\"", EtherTunTapIfName);
     }
     else
     {
       OLSR_PRINTF(
-        9,
-        "%s: --> unpacked and forwarded to \"%s\"\n",
+        8,
+        "%s: --> unpacked and delivered locally on \"%s\"\n",
         PLUGIN_NAME_SHORT,
         EtherTunTapIfName);
     }
   }
 
-  /* Lookup main address of forwarding node */
-  forwarder = mid_lookup_main_addr(fromIp);
-  if (forwarder == NULL)
-  {
-    forwarder = fromIp;
-  }
-
   /* Check if I am MPR for the forwarder */
-  iAmMpr = (olsr_lookup_mprs_set(forwarder) != NULL);
+  /* TODO: olsr_lookup_mprs_set() is not thread-safe! */
+  iAmMpr = (olsr_lookup_mprs_set(MainAddressOf(forwardedBy)) != NULL);
 
-  memset(&encapDest, 0, sizeof(encapDest));
-  encapDest.sin_family = AF_INET;
-  encapDest.sin_port = htons(BMF_ENCAP_PORT);
+  memset(&forwardTo, 0, sizeof(forwardTo));
+  forwardTo.sin_family = AF_INET;
+  forwardTo.sin_port = htons(BMF_ENCAP_PORT);
 
-  nextFwIntf = BmfInterfaces;
-  while (nextFwIntf != NULL)
-  {
-    struct TBmfInterface* fwIntf = nextFwIntf;
-    nextFwIntf = fwIntf->next;
+  encapsulationUdpDataLen = GetEncapsulationUdpDataLength(encapsulationUdpData);
 
+  /* Check with each network interface what needs to be done on it */
+  for (walker = BmfInterfaces; walker != NULL; walker = walker->next)
+  {
     /* Depending on certain conditions, decide whether or not to forward
      * the packet, and if it is forwarded, in which form (encapsulated
      * or not). These conditions are:
@@ -643,157 +704,133 @@
      *   the flooding.
      */
 
-    /* Forward from OLSR interface to non-OLSR interface: unpack encapsulated
-     * packet, [decrease TTL] and forward */
-    if (fwIntf->olsrIntf == NULL)
+    /* To a non-OLSR interface: unpack encapsulated packet and forward */
+    if (walker->olsrIntf == NULL)
     {
-#ifdef DO_TTL_STUFF
-      /* If the TTL is to become 0, do not forward this packet */
-      if (GetIpTtl(ethPkt) <= 1)
+      int nBytesWritten;
+
+      /* If the encapsulated Ethernet frame is an IP local broadcast packet,
+       * update its destination address to match the subnet of the network
+       * interface on which the packet is being sent. */
+      CheckAndUpdateLocalBroadcast(GetIpPacket(ethernetFrame), &walker->broadAddr);
+
+      nBytesWritten = write(walker->capturingSkfd, ethernetFrame, ethernetFrameLen);
+      if (nBytesWritten != ethernetFrameLen)
       {
-        OLSR_PRINTF(
-          9,
-          "%s: --> not forwarding on \"%s\": TTL=0\n",
-          PLUGIN_NAME_SHORT,
-          fwIntf->ifName);
+        BmfPError("write() error forwarding unpacked encapsulated pkt on \"%s\"", walker->ifName);
       }
       else
       {
-        struct TSaveTtl sttl;
-#endif
+        /* Increase counter */
+        walker->nBmfPacketsTx++;
 
-        /* If the destination address is not a multicast address, it is assumed to be
-         * a local broadcast packet. Update the destination address to match the subnet
-         * of the network interface on which the packet is being sent. */
-        CheckAndUpdateLocalBroadcast(ethPkt, &fwIntf->broadAddr);
-
-#ifdef DO_TTL_STUFF
-        /* Save IP header checksum and the TTL-value of the packet, then 
-         * decrease the TTL by 1 before writing */
-        SaveTtlAndChecksum(ethPkt, &sttl);
-
-        /* Decrease the TTL by 1 before writing */
-        DecreaseTtlAndUpdateHeaderChecksum(ethPkt);
-#endif
-
-        nBytesWritten = write(fwIntf->capturingSkfd, ethPkt, ethPktLen);
-        if (nBytesWritten != ethPktLen)
-        {
-          olsr_printf(
-            1,
-            "%s: write() error forwarding unpacked encapsulated pkt to \"%s\": %s\n",
-            PLUGIN_NAME,
-            fwIntf->ifName,
-            strerror(errno));
-        }
-        else
-        {
-          OLSR_PRINTF(
-            9,
-            "%s: --> unpacked and forwarded to \"%s\"\n",
-            PLUGIN_NAME_SHORT,
-            fwIntf->ifName);
-        }
-
-#ifdef DO_TTL_STUFF
-        /* Restore the IP header checksum and the TTL-value of the packet */
-        RestoreTtlAndChecksum(ethPkt, &sttl);
-
-      } /* if (GetIpTtl(ethPkt) <= 1) */
-#endif
-    } /* if (fwIntf->olsrIntf == NULL) */
+        OLSR_PRINTF(
+          8,
+          "%s: --> unpacked and forwarded on \"%s\"\n",
+          PLUGIN_NAME_SHORT,
+          walker->ifName);
+      }
+    } /* if (walker->olsrIntf == NULL) */
 
-    /* Forward from OLSR interface to OLSR interface: forward the packet if this
-     * node is selected as MPR by the forwarding node */
+    /* To a OLSR interface: forward the packet if this node is selected as MPR by the forwarding node */
     else if (iAmMpr)
     {
-      /* Change source MAC address to that of sending interface */
-      memcpy(buffer + IFHWADDRLEN, fwIntf->macAddr, IFHWADDRLEN);
+      int nBytesWritten;
+
+      /* Compose destination of encapsulation packet */
+      if (ComposeEnapsulationDestination(
+        walker,
+        &mcSrc,
+        forwardedBy,
+        forwardedTo,
+        &forwardTo) == 0)
+      {
+        OLSR_PRINTF(
+          8,
+          "%s: --> not forwarding on \"%s\": there is no neighbor that needs my retransmission\n",
+          PLUGIN_NAME_SHORT,
+          walker->ifName);
 
-      /* Destination address is local broadcast */
-      encapDest.sin_addr.s_addr = ((struct sockaddr_in*)&fwIntf->olsrIntf->int_broadaddr)->sin_addr.s_addr;
+        continue; /* for */
+      }
 
       nBytesWritten = sendto(
-        fwIntf->encapsulatingSkfd,
-        buffer,
-        len,
+        walker->encapsulatingSkfd,
+        encapsulationUdpData,
+        encapsulationUdpDataLen,
         MSG_DONTROUTE,
-        (struct sockaddr*) &encapDest,
-        sizeof(encapDest));                   
+        (struct sockaddr*) &forwardTo,
+        sizeof(forwardTo));                   
 
-      if (nBytesWritten != len)
+      if (nBytesWritten != encapsulationUdpDataLen)
       {
-        olsr_printf(
-          1,
-          "%s: sendto() error forwarding encapsulated pkt via \"%s\": %s\n",
-          PLUGIN_NAME,
-          fwIntf->ifName,
-          strerror(errno));
+        BmfPError("sendto() error forwarding encapsulated pkt on \"%s\"", walker->ifName);
       }
       else
       {
+        /* Increase counter */
+        walker->nBmfPacketsTx++;
+
         OLSR_PRINTF(
-          9,
-          "%s: --> forwarded to \"%s\"\n",
+          8,
+          "%s: --> forwarded on \"%s\" to %s\n",
           PLUGIN_NAME_SHORT,
-          fwIntf->ifName);
+          walker->ifName,
+          inet_ntoa(forwardTo.sin_addr));
       }
     }  /* else if (iAmMpr) */
-    else /* fwIntf->olsrIntf != NULL && !iAmMpr */
+    else /* walker->olsrIntf != NULL && !iAmMpr */
     {
-      /* fwIntf is an OLSR interface and I am not selected as MPR */
+      /* 'walker' is an OLSR interface and I am not selected as MPR */
       OLSR_PRINTF(
-        9,
-        "%s: --> not forwarding to \"%s\": I am not selected as MPR by %s\n",
+        8,
+        "%s: --> not forwarding on \"%s\": I am not selected as MPR by %s\n",
         PLUGIN_NAME_SHORT,
-        fwIntf->ifName,
-        olsr_ip_to_string(fromIp));
+        walker->ifName,
+        olsr_ip_to_string(forwardedBy));
     }
-  } /* while (nextFwIntf != NULL) */
+  } /* for */
 }
 
 /* -------------------------------------------------------------------------
  * Function   : BmfTunPacketCaptured
- * Description: Handle a raw IP packet captured outgoing on the tuntap interface
- * Input      : buffer - space for the encapsulation header, followed by
- *                the captured packet
- *              len - the number of octets in the encapsulation header plus
- *                captured packet
+ * Description: Handle a Ethernet frame, captured outgoing on the tuntap interface
+ * Input      : encapsulationUdpData - space for the encapsulation header, followed by
+ *                the captured Ethernet frame
  * Output     : none
  * Return     : none
  * Data Used  : none
  * Notes      : The packet is assumed to be captured on a socket of family
  *              PF_PACKET and type SOCK_RAW.
  * ------------------------------------------------------------------------- */
-static void BmfTunPacketCaptured(
-  unsigned char* buffer,
-  ssize_t len)
+static void BmfTunPacketCaptured(unsigned char* encapsulationUdpData)
 {
   union olsr_ip_addr srcIp;
-  union olsr_ip_addr destIp;
-  struct TBmfInterface* nextFwIntf;
-  unsigned char* ethPkt = buffer + ENCAP_HDR_LEN;
-  ssize_t ethPktLen = len - ENCAP_HDR_LEN;
-  struct ip* ipData;
+  union olsr_ip_addr dstIp;
+  union olsr_ip_addr broadAddr;
+  struct TBmfInterface* walker;
+  unsigned char* ethernetFrame;
+  u_int16_t ethernetFrameLen;
+  struct ip* ipHeader;
   u_int32_t crc32;
   struct TEncapHeader* encapHdr;
-  struct sockaddr broadAddr;
-  u_int16_t type;
+
+  ethernetFrame = GetEthernetFrame(encapsulationUdpData);
+  ethernetFrameLen = GetFrameLength(ethernetFrame);
 
   /* Only forward IPv4 packets */
-  memcpy(&type, ethPkt + ETH_TYPE_OFFSET, 2);
-  if (ntohs(type) != IPV4_TYPE)
+  if (GetEtherType(ethernetFrame) != IPV4_TYPE)
   {
     return;
   }
 
-  ipData = (struct ip*)(ethPkt + IP_HDR_OFFSET);
+  ipHeader = GetIpHeader(ethernetFrame);
 
-  /* Only forward multicast packets, or local broadcast packets if specified */
-  COPY_IP(&destIp, &ipData->ip_dst);
-  ((struct sockaddr_in*)&broadAddr)->sin_addr.s_addr = htonl(EtherTunTapIpBroadcast);
-  if (IsMulticast(&destIp) ||
-      (EnableLocalBroadcast != 0 && IsLocalBroadcast(&destIp, &broadAddr)))
+  /* Only forward multicast packets. If configured, also forward local broadcast packets */
+  COPY_IP(&dstIp, &ipHeader->ip_dst);
+  broadAddr.v4 = htonl(EtherTunTapIpBroadcast);
+  if (IsMulticast(&dstIp) ||
+      (EnableLocalBroadcast != 0 && COMP_IP(&dstIp, &broadAddr)))
   {
     /* continue */
   }
@@ -802,102 +839,77 @@
     return;
   }
 
-  COPY_IP(&srcIp, &ipData->ip_src);
+  COPY_IP(&srcIp, &ipHeader->ip_src);
   OLSR_PRINTF(
-    9,
-    "%s: outgoing pkt of %d bytes captured on tuntap interface \"%s\": %s->%s\n",
+    8,
+    "%s: outgoing pkt of %ld bytes captured on tuntap interface \"%s\": %s->%s\n",
     PLUGIN_NAME_SHORT,
-    ethPktLen,
+    (long)ethernetFrameLen,
     EtherTunTapIfName,
     olsr_ip_to_string(&srcIp),
-    olsr_ip_to_string(&destIp));
+    olsr_ip_to_string(&dstIp));
 
   /* Check if this packet was seen recently */
-  crc32 = PacketCrc32(ethPkt, ethPktLen);
+  crc32 = PacketCrc32(ethernetFrame, ethernetFrameLen);
   if (CheckAndMarkRecentPacket(Hash16(crc32)))
   {
     OLSR_PRINTF(
-      9,
+      8,
       "%s: --> discarding: packet is duplicate\n",
       PLUGIN_NAME_SHORT);
     return;
   }
 
   /* Compose encapsulation header */
-  encapHdr = (struct TEncapHeader*) buffer;
+  encapHdr = (struct TEncapHeader*) encapsulationUdpData;
   memset (encapHdr, 0, ENCAP_HDR_LEN);
   encapHdr->crc32 = htonl(crc32);
 
-  /* Check with each interface what needs to be done on it */
-  nextFwIntf = BmfInterfaces;
-  while (nextFwIntf != NULL)
+  /* Check with each network interface what needs to be done on it */
+  for (walker = BmfInterfaces; walker != NULL; walker = walker->next)
   {
-    int isToOlsrIntf;
-
-    struct TBmfInterface* fwIntf = nextFwIntf;
-    nextFwIntf = fwIntf->next;
-
     /* Is the forwarding interface OLSR-enabled? */
-    isToOlsrIntf = (fwIntf->olsrIntf != NULL);
-
-    /* Depending on certain conditions, we decide whether or not to forward
-     * the packet, and if it is forwarded, in which form (encapsulated
-     * or not). These conditions are:
-     * - is the packet going out on an OLSR interface or not? (isToOlsrIntf)
-     *
-     * Based on these conditions, the following cases can be distinguished:
-     *
-     * - Case 1: What to do with a packet for an OLSR interface?
-     *   Answer: Encapsulate and forward it.
-     *
-     * - Case 2: What to do with a packet for a non-OLSR interface?
-     *   Answer 1: nothing. Multicast routing between non-OLSR interfaces
-     *   is to be done by other protocols (e.g. PIM, DVMRP).
-     *   Answer 2 (better): Forward it.
-     */
-
-    if (isToOlsrIntf)
+    if (walker->olsrIntf != NULL)
     {
-      /* Case 1: Forward to an OLSR interface.
-       * Encapsulate and forward packet. */
+      /* On an OLSR interface: encapsulate and forward packet. */
 
-      EncapsulateAndForwardPacket(fwIntf, buffer, len);
+      EncapsulateAndForwardPacket(walker, encapsulationUdpData);
     }
     else
     {
-      /* Case 2: Forward to a non-OLSR interface. */
+      /* On a non-OLSR interface: what to do?
+       * Answer 1: nothing. Multicast routing between non-OLSR interfaces
+       * is to be done by other protocols (e.g. PIM, DVMRP).
+       * Answer 2 (better): Forward it. */
 
       int nBytesWritten;
 
       /* Change source MAC address to that of sending interface */
-      memcpy(ethPkt + IFHWADDRLEN, fwIntf->macAddr, IFHWADDRLEN);
+      SetFrameSourceMac(ethernetFrame, walker->macAddr);
 
-      /* If the destination address is not a multicast address, it is assumed to be
-       * a local broadcast packet. Update the destination address to match the subnet
-       * of the network interface on which the packet is being sent. */
-      CheckAndUpdateLocalBroadcast(ethPkt, &fwIntf->broadAddr);
+      /* If the encapsulated Ethernet frame is an IP local broadcast packet,
+       * update its destination address to match the subnet of the network
+       * interface on which the packet is being sent. */
+      CheckAndUpdateLocalBroadcast(GetIpPacket(ethernetFrame), &walker->broadAddr);
 
-      nBytesWritten = write(fwIntf->capturingSkfd, ethPkt, ethPktLen);
-      if (nBytesWritten != ethPktLen)
+      nBytesWritten = write(walker->capturingSkfd, ethernetFrame, ethernetFrameLen);
+      if (nBytesWritten != ethernetFrameLen)
       {
-        olsr_printf(
-          1,
-          "%s: write() error forwarding pkt for %s to \"%s\": %s\n",
-          PLUGIN_NAME,
-          olsr_ip_to_string(&destIp),
-          fwIntf->ifName,
-          strerror(errno));
+        BmfPError("write() error forwarding pkt on \"%s\"", walker->ifName);
       }
       else
       {
+        /* Increase counter */
+        walker->nBmfPacketsTx++;
+
         OLSR_PRINTF(
-          9,
+          8,
           "%s: --> forwarded from non-OLSR to non-OLSR \"%s\"\n",
           PLUGIN_NAME_SHORT,
-          fwIntf->ifName);
-      }
-    } /* if (isToOlsrIntf) */
-  } /* while (nextFwIntf != NULL) */
+          walker->ifName);
+      } /* if */
+    } /* if */
+  } /* for */
 }
 
 /* -------------------------------------------------------------------------
@@ -911,13 +923,11 @@
  * ------------------------------------------------------------------------- */
 static void DoBmf(void)
 {
-  struct TBmfInterface* currIf;
   int nFdBitsSet;
-  /*unsigned char* rxBuffer = malloc(BMF_BUFFER_SIZE);*/
   unsigned char rxBuffer[BMF_BUFFER_SIZE];
   fd_set rxFdSet;
 
-  assert(HighestSkfd >= 0/* && rxBuffer != NULL*/);
+  assert(HighestSkfd >= 0);
 
   /* Make a local copy of the set of file descriptors that select() can
    * modify to indicate which descriptors actually changed status */
@@ -930,109 +940,184 @@
   {
     if (errno != EINTR)
     {
-      olsr_printf(1, "%s: select() error: %s\n", PLUGIN_NAME, strerror(errno));
+      BmfPError("select() error");
     }
     return;
   }
 
   while (nFdBitsSet > 0)
   {
+    struct TBmfInterface* walker;
+
     /* Check if a packet was received on the capturing socket (if any)
      * of each network interface */
-    struct TBmfInterface* nextIf = BmfInterfaces;
-    while (nextIf != NULL)
+    for (walker = BmfInterfaces; walker != NULL; walker = walker->next)
     {
-      int skfd;
-
-      currIf = nextIf;
-      nextIf = currIf->next;
-
-      skfd = currIf->capturingSkfd;
+      int skfd = walker->capturingSkfd;
       if (skfd >= 0 && (FD_ISSET(skfd, &rxFdSet)))
       {
         struct sockaddr_ll pktAddr;
         socklen_t addrLen = sizeof(pktAddr);
         int nBytes;
-        unsigned char* ethPkt;
+        unsigned char* ethernetFrame;
 
         /* A packet was captured. */
 
         nFdBitsSet--;
 
-        /* Receive the packet, leaving space for the BMF encapsulation header */
-        ethPkt = rxBuffer + ENCAP_HDR_LEN;
+        /* Receive the captured Ethernet frame, leaving space for the BMF
+         * encapsulation header */
+        ethernetFrame = GetEthernetFrame(rxBuffer);
         nBytes = recvfrom(
           skfd,
-          ethPkt,
+          ethernetFrame,
           BMF_BUFFER_SIZE - ENCAP_HDR_LEN,
           0,
           (struct sockaddr*)&pktAddr,
           &addrLen);
         if (nBytes < 0)
         {
+          BmfPError("recvfrom() error on \"%s\"", walker->ifName);
+
+          continue; /* for */
+        } /* if (nBytes < 0) */
+
+        /* Check if the number of received bytes is large enough for an Ethernet
+         * frame which contains at least a minimum-size IP header.
+         * Note: There is an apparent bug in the packet socket implementation in
+         * combination with VLAN interfaces. On a VLAN interface, the value returned
+         * by 'recvfrom' may (but need not) be 4 (bytes) larger than the value
+         * returned on a non-VLAN interface, for the same ethernet frame. */
+        if (nBytes < IP_HDR_OFFSET + (int)sizeof(struct ip))
+        {
           olsr_printf(
             1,
-            "%s: recvfrom() error on \"%s\": %s\n",
+            "%s: captured frame too short (%d bytes) on \"%s\"\n",
             PLUGIN_NAME,
-            currIf->ifName,
-            strerror(errno));
+            nBytes,
+            walker->ifName);
+
+          continue; /* for */
+        }
+
+        if (pktAddr.sll_pkttype == PACKET_OUTGOING ||
+            pktAddr.sll_pkttype == PACKET_MULTICAST ||
+            pktAddr.sll_pkttype == PACKET_BROADCAST)
+        {
+          /* A multicast or broadcast packet was captured */
+
+          BmfPacketCaptured(walker, pktAddr.sll_pkttype, rxBuffer);
+
+        } /* if (pktAddr.sll_pkttype == ...) */
+      } /* if (skfd >= 0 && (FD_ISSET...)) */
+    } /* for */
+    
+    /* Check if a BMF encapsulation packet was received on the listening
+     * socket (if any) of each network interface */
+    for (walker = BmfInterfaces; walker != NULL; walker = walker->next)
+    {
+      int skfd = walker->listeningSkfd;
+      if (skfd >= 0 && (FD_ISSET(skfd, &rxFdSet)))
+      {
+        struct sockaddr_ll pktAddr;
+        socklen_t addrLen = sizeof(pktAddr);
+        int nBytes;
+        int minimumLength;
+        struct ip* ipHeader;
+        struct udphdr* udpHeader;
+        u_int16_t destPort;
+        union olsr_ip_addr forwardedBy;
+        union olsr_ip_addr forwardedTo;
+
+        /* Heard a BMF packet */
+
+        nFdBitsSet--;
+
+        nBytes = recvfrom(
+          skfd,
+          rxBuffer,
+          BMF_BUFFER_SIZE,
+          0,
+          (struct sockaddr*)&pktAddr,
+          &addrLen);
+        if (nBytes < 0)
+        {
+          BmfPError("recvfrom() error on \"%s\"", walker->ifName);
+
+          continue; /* for */
+        } /* if (nBytes < 0) */
+
+        if (pktAddr.sll_pkttype != PACKET_OTHERHOST)
+        {
+          continue; /* for */
+        } /* if (pktAddr.sll_pkttype ...) */
+
+        /* Check if the received packet is UDP - BMF port */
+        ipHeader = (struct ip*)rxBuffer;
+        if (ipHeader->ip_p != SOL_UDP)
+        {
+          /* Not UDP */
+          continue; /* for */
         }
-        else if (nBytes < IP_HDR_OFFSET + (int)sizeof(struct iphdr))
+
+        udpHeader = (struct udphdr*)(rxBuffer + GetHeaderLength(rxBuffer));
+        destPort = ntohs(udpHeader->dest);
+        if (destPort != BMF_ENCAP_PORT)
+        {
+          /* Not BMF */
+          continue; /* for */
+        }
+
+        /* Check if the number of received bytes is large enough for a minimal BMF
+         * encapsulation packet, at least:
+         * - the IP header of the encapsulation IP packet
+         * - the UDP header of the encapsulation IP packet
+         * - the encapsulation header
+         * - the Ethernet header in the encapsulated Ethernet packet
+         * - a minimum IP header inside the encapsulated packet
+         * Note: on a VLAN interface, the value returned by 'recvfrom' may (but need
+         * not) be 4 (bytes) larger than the value returned on a non-VLAN interface, for
+         * the same ethernet frame. */
+        minimumLength =
+          GetHeaderLength(rxBuffer) +
+          sizeof(struct udphdr) +
+          ENCAP_HDR_LEN +
+          IP_HDR_OFFSET +
+          sizeof(struct ip);
+        if (nBytes < minimumLength)
         {
           olsr_printf(
             1,
-            "%s: captured packet too short (%d bytes) on \"%s\"\n",
+            "%s: captured a too short encapsulation packet (%d bytes) on \"%s\"\n",
             PLUGIN_NAME,
             nBytes,
-            currIf->ifName);
+            walker->ifName);
+
+          continue; /* for */
         }
-        else
-        {
-          /* Don't trust the number of bytes as returned from 'recvfrom':
-           * that number may be 4 bytes too large, in case the receiving
-           * network interface is a VLAN interface. */
-          nBytes = IP_HDR_OFFSET + GetIpPacketLength(ethPkt);
-
-          /* Don't let BMF crash by sending too short packets */
-          if (nBytes >= IP_HDR_OFFSET + GetIpHeaderLength(ethPkt))
-          {
-            if (pktAddr.sll_pkttype == PACKET_OUTGOING ||
-                pktAddr.sll_pkttype == PACKET_MULTICAST ||
-                pktAddr.sll_pkttype == PACKET_BROADCAST)
-            {
-              /* A multicast or broadcast packet was captured */
-              BmfPacketCaptured(currIf, pktAddr.sll_pkttype, rxBuffer, nBytes + ENCAP_HDR_LEN);
-            }
-          }
-          else
-          {
-            olsr_printf(
-              1,
-              "%s: captured packet too short (%d bytes) on \"%s\"\n",
-              PLUGIN_NAME,
-              nBytes,
-              currIf->ifName);
-          }
-        } /* if (nBytes < 0) */
+
+        COPY_IP(&forwardedBy, &ipHeader->ip_src);
+        COPY_IP(&forwardedTo, &ipHeader->ip_dst);
+        BmfEncapsulationPacketReceived(
+          walker,
+          &forwardedBy,
+          &forwardedTo,
+          rxBuffer + GetHeaderLength(rxBuffer) + sizeof(struct udphdr));
+
       } /* if (skfd >= 0 && (FD_ISSET...)) */
-    } /* while (nextIf != NULL) */
-    
+    } /* for */
+
     /* Check if a packet was received on the encapsulating socket (if any)
      * of each network interface */
-    nextIf = BmfInterfaces;
-    while (nextIf != NULL)
+    for (walker = BmfInterfaces; walker != NULL; walker = walker->next)
     {
-      int skfd;
-
-      currIf = nextIf;
-      nextIf = currIf->next;
-
-      skfd = currIf->encapsulatingSkfd;
+      int skfd = walker->encapsulatingSkfd;
       if (skfd >= 0 && (FD_ISSET(skfd, &rxFdSet)))
       {
         struct sockaddr_in from;
         socklen_t fromLen = sizeof(from);
         int nBytes;
+        union olsr_ip_addr forwardedBy;
 
         /* An encapsulated packet was received */
 
@@ -1047,52 +1132,52 @@
           &fromLen);
         if (nBytes < 0)
         {
+          BmfPError("recvfrom() error on \"%s\"", walker->ifName);
+
+          continue; /* for */
+        } /* if (nBytes < 0) */
+
+        COPY_IP(&forwardedBy, &from.sin_addr.s_addr);
+
+        /* Check if the number of received bytes is large enough for a minimal BMF
+         * encapsulation packet, at least:
+         * - the encapsulation header
+         * - the Ethernet header in the encapsulated Ethernet packet
+         * - a minimum IP header inside the encapsulated packet */
+        if (nBytes < ENCAP_HDR_LEN + IP_HDR_OFFSET + (int)sizeof(struct ip))
+        {
           olsr_printf(
             1,
-            "%s: recvfrom() error on \"%s\": %s\n",
+            "%s: received a too short encapsulation packet (%d bytes) from %s on \"%s\"\n",
             PLUGIN_NAME,
-            currIf->ifName,
-            strerror(errno));
+            nBytes,
+            olsr_ip_to_string(&forwardedBy),
+            walker->ifName);
+
+          continue; /* for */
         }
-        else
-        {
-          /* Don't let BMF crash by sending too short packets. */
-          if (nBytes >= IP_HDR_OFFSET + GetIpHeaderLength(rxBuffer))
-          {
-            union olsr_ip_addr srcIp;
-            COPY_IP(&srcIp, &from.sin_addr.s_addr);
-            BmfEncapsulatedPacketReceived(currIf, &srcIp, rxBuffer, nBytes);
-          }
-          else
-          {
-            olsr_printf(
-              1,
-              "%s: encapsulated packet too short (%d bytes) from %s on \"%s\"\n",
-              PLUGIN_NAME,
-              nBytes,
-              inet_ntoa(from.sin_addr),
-              currIf->ifName);
-          }
-        } /* if (nBytes < 0) */
+
+        BmfEncapsulationPacketReceived(walker, &forwardedBy, NULL, rxBuffer);
+
       } /* if (skfd >= 0 && (FD_ISSET...)) */
-    } /* while (nextIf != NULL) */
+    } /* for */
 
     if (nFdBitsSet > 0 && FD_ISSET(EtherTunTapFd, &rxFdSet))
     {
-      /* Check if an application has sent a packet to the tuntap
+      /* Check if an application has sent a packet out via the tuntap
        * network interface */
 
       int nBytes;
-      unsigned char* ethPkt;
+      unsigned char* ethernetFrame;
       unsigned char* bufferToRead;
       size_t nBytesToRead;
 
       nFdBitsSet--;
 
       /* Receive the packet, leaving space for the BMF encapsulation header */
-      ethPkt = rxBuffer + ENCAP_HDR_LEN;
+      ethernetFrame = GetEthernetFrame(rxBuffer);
     
-      bufferToRead = ethPkt;
+      bufferToRead = ethernetFrame;
       nBytesToRead = BMF_BUFFER_SIZE - ENCAP_HDR_LEN;
       if (TunOrTap == TT_TUN)
       {
@@ -1102,8 +1187,8 @@
         bufferToRead += IP_HDR_OFFSET;
         nBytesToRead -= IP_HDR_OFFSET;
 
-        /* Compose an Ethernet header, in case other BMF-nodes are receiving
-         * their BMF packets on a tap-interface. */
+        /* Compose a valid Ethernet header, for other BMF-nodes which may be
+         * receiving their BMF packets on a tap-interface. */
 
         /* Use all-ones as destination MAC address. When the IP destination is
          * a multicast address, the destination MAC address should normally also
@@ -1111,56 +1196,31 @@
          * the destination MAC should be 01:00:5e:00:00:01. However, it does not
          * seem to matter when the destination MAC address is set to all-ones
          * in that case. */
-        memset(ethPkt, 0xFF, IFHWADDRLEN);
+        memset(ethernetFrame, 0xFF, IFHWADDRLEN);
 
         /* Source MAC address is not important. Set to all-zeros */
-        memset(ethPkt + IFHWADDRLEN, 0x00, IFHWADDRLEN);
+        memset(ethernetFrame + IFHWADDRLEN, 0x00, IFHWADDRLEN);
 
         /* Ethertype = 0800 = IP */
         type = htons(0x0800);
-        memcpy(ethPkt + ETH_TYPE_OFFSET, &type, 2);
+        memcpy(ethernetFrame + ETH_TYPE_OFFSET, &type, 2);
       }
 
-      nBytes = read(
-        EtherTunTapFd,
-        bufferToRead,
-        nBytesToRead);
+      nBytes = read(EtherTunTapFd, bufferToRead, nBytesToRead);
 
       if (nBytes < 0)
       {
-        if (errno != EAGAIN)
-        {
-          olsr_printf(
-            1,
-            "%s: recvfrom() error on \"%s\": %s\n",
-            PLUGIN_NAME,
-            EtherTunTapIfName,
-            strerror(errno));
-        }
-      }
-      else if (nBytes < (int)sizeof(struct iphdr))
-      {
-        olsr_printf(
-          1,
-          "%s: captured packet too short (%d bytes) on \"%s\"\n",
-          PLUGIN_NAME,
-          nBytes,
-          EtherTunTapIfName);
+        BmfPError("recvfrom() error on \"%s\"", EtherTunTapIfName);
       }
       else
       {
-        /* Don't trust the number of bytes as returned from 'recvfrom':
-         * that number may be 4 bytes too large, in case the receiving
-         * network interface is a VLAN interface. */
-        nBytes = IP_HDR_OFFSET + GetIpPacketLength(ethPkt);
-
-        /* Don't let BMF crash by sending too short packets */
-        if (nBytes >= IP_HDR_OFFSET + GetIpHeaderLength(ethPkt))
+        /* Check if the number of received bytes is large enough for an Ethernet
+         * frame which contains at least a minimum-size IP header */
+        if (TunOrTap == TT_TUN)
         {
-          /* An outbound packet was captured */
-          BmfTunPacketCaptured(rxBuffer, nBytes + ENCAP_HDR_LEN);
+          nBytes += IP_HDR_OFFSET;
         }
-        else
+        if (nBytes < IP_HDR_OFFSET + (int)sizeof(struct ip))
         {
           olsr_printf(
             1,
@@ -1168,11 +1228,17 @@
             PLUGIN_NAME,
             nBytes,
             EtherTunTapIfName);
-        } /* if (nBytes >= IP_HDR_OFFSET... */
+        }
+        else
+        {
+          /* An outbound packet was captured */
+
+          BmfTunPacketCaptured(rxBuffer);
+
+        } /* if (nBytes < IP_HDR_OFFSET... */
       } /* if (nBytes < 0) */
     } /* if (nFdBitsSet > 0 && ... */
   } /* while (nFdBitsSet > 0) */
-  /*free(rxBuffer);*/
 }
 
 /* -------------------------------------------------------------------------
@@ -1183,7 +1249,7 @@
  * Return     : none
  * Data Used  : BmfThreadRunning
  * ------------------------------------------------------------------------- */
-static void BmfSignalHandler(int signo)
+static void BmfSignalHandler(int signo __attribute__((unused)))
 {
   BmfThreadRunning = 0;
 }
